/*
 * Copyright (c) 2010-2011, The MiCode Open Source Community (www.micode.net)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package net.micode.notes.gtask.data;

import android.content.ContentResolver;
import android.content.ContentUris;
import android.content.ContentValues;
import android.content.Context;
import android.database.Cursor;
import android.net.Uri;
import android.util.Log;

import net.micode.notes.data.Notes;
import net.micode.notes.data.Notes.DataColumns;
import net.micode.notes.data.Notes.DataConstants;
import net.micode.notes.data.Notes.NoteColumns;
import net.micode.notes.data.NotesDatabaseHelper.TABLE;
import net.micode.notes.gtask.exception.ActionFailureException;

import org.json.JSONException;
import org.json.JSONObject;

/**
 * @Package: net.micode.notes.gtask.data
 * @ClassName:  SqlData
 * @Description:
 * 封装了对数据库中数据的读取、更新和提交操作，可以用于管理和操作数据库中的数据。
 * @Author: Dong Jiaqi
 * @CreateDate: 12/24/2023 10:58 AM
 */
public class SqlData {
    private static final String TAG = SqlData.class.getSimpleName();

    private static final int INVALID_ID = -99999;//定义了一个名为 INVALID_ID 的私有静态整型常量，并赋值为 -99999，被用来表示无效的 ID 值。

    public static final String[] PROJECTION_DATA = new String[] {
            DataColumns.ID, DataColumns.MIME_TYPE, DataColumns.CONTENT, DataColumns.DATA1,
            DataColumns.DATA3
    };//定义了一个名为 PROJECTION_DATA 的字符串数组，其中包含了一组列名

    public static final int DATA_ID_COLUMN = 0;//表示数据的 ID 在数据列中的索引位置，即第一列。

    public static final int DATA_MIME_TYPE_COLUMN = 1;//表示数据的 MIME 类型在数据列中的索引位置，即第二列。

    public static final int DATA_CONTENT_COLUMN = 2;//表示数据的内容在数据列中的索引位置，即第三列。

    public static final int DATA_CONTENT_DATA_1_COLUMN = 3;//表示数据的内容数据1在数据列中的索引位置，即第四列。

    public static final int DATA_CONTENT_DATA_3_COLUMN = 4;//表示数据的内容数据3在数据列中的索引位置，即第五列。

    private ContentResolver mContentResolver;

    private boolean mIsCreate;

    private long mDataId;

    private String mDataMimeType;

    private String mDataContent;

    private long mDataContentData1;

    private String mDataContentData3;

    private ContentValues mDiffDataValues;

    /**
     * 构造函数，接收一个Context对象作为参数，并初始化成员变量。
     * @param context 用于获取应用程序的上下文信息，以便后续操作数据库。
     */
    public SqlData(Context context) {
        mContentResolver = context.getContentResolver();//这是构造方法的定义，表明这是一个公共的构造方法，并且接受一个 Context 类型的参数。
        mIsCreate = true;
        mDataId = INVALID_ID;
        mDataMimeType = DataConstants.NOTE;
        mDataContent = "";//成员变量初始化
        mDataContentData1 = 0;
        mDataContentData3 = "";
        mDiffDataValues = new ContentValues();//创建新的ContentValues对象
    }

    /**
     * 构造函数，接收一个Context对象和一个Cursor对象作为参数，并根据Cursor对象加载成员变量的值。
     * @param context 用于获取应用程序的上下文信息，以便后续操作数据库；
     * @param c Cursor 对象用于获取数据库中的数据。
     */
    public SqlData(Context context, Cursor c) {
        mContentResolver = context.getContentResolver();
        mIsCreate = false;
        loadFromCursor(c);//调用 loadFromCursor() 方法，将传入的 Cursor 对象作为参数，以从 Cursor 对象中加载数据库中的数据到 SqlData 对象的成员变量中。
        mDiffDataValues = new ContentValues();
    }

    /**
     * 从传入的 Cursor 对象中加载数据，并将数据赋值给 SqlData 对象的各个成员变量。
     * @param c Cursor 对象用于获取数据库中的数据
     */
    private void loadFromCursor(Cursor c) {
        mDataId = c.getLong(DATA_ID_COLUMN);//从 Cursor 对象中获取指定列索引为 DATA_ID_COLUMN 的长整型数据，并赋值给 mDataId 成员变量。
        mDataMimeType = c.getString(DATA_MIME_TYPE_COLUMN);//从 Cursor 对象中获取指定列索引为 DATA_MIME_TYPE_COLUMN 的字符串数据，并赋值给 mDataMimeType 成员变量。
        mDataContent = c.getString(DATA_CONTENT_COLUMN);
        mDataContentData1 = c.getLong(DATA_CONTENT_DATA_1_COLUMN);
        mDataContentData3 = c.getString(DATA_CONTENT_DATA_3_COLUMN);
    }

    /**
     * 根据传入的JSON对象设置成员变量的值。根据JSON对象中的字段值判断是否需要更新成员变量，并将需要更新的值存储在mDiffDataValues对象中。
     * @param js JSONObject对象用于获取数据
     * @throws JSONException 抛出的异常
     */
    public void setContent(JSONObject js) throws JSONException {
        long dataId = js.has(DataColumns.ID) ? js.getLong(DataColumns.ID) : INVALID_ID;//检查 JSON 对象 js 中是否包含名为 DataColumns.ID 的字段，如果包含则将其转换为 long 类型并赋给 dataId，否则将 INVALID_ID 赋给 dataId。
        if (mIsCreate || mDataId != dataId) {//检查是否正在创建新数据（mIsCreate 为 true），或者已有数据的 dataId 是否与新获取的 dataId 不同。
            mDiffDataValues.put(DataColumns.ID, dataId);//如果满足条件，则将 DataColumns.ID 和对应的 dataId 放入 mDiffDataValues 中。
        }
        mDataId = dataId;

        String dataMimeType = js.has(DataColumns.MIME_TYPE) ? js.getString(DataColumns.MIME_TYPE)
                : DataConstants.NOTE;
        if (mIsCreate || !mDataMimeType.equals(dataMimeType)) {
            mDiffDataValues.put(DataColumns.MIME_TYPE, dataMimeType);
        }
        mDataMimeType = dataMimeType;

        String dataContent = js.has(DataColumns.CONTENT) ? js.getString(DataColumns.CONTENT) : "";
        if (mIsCreate || !mDataContent.equals(dataContent)) {
            mDiffDataValues.put(DataColumns.CONTENT, dataContent);
        }
        mDataContent = dataContent;

        long dataContentData1 = js.has(DataColumns.DATA1) ? js.getLong(DataColumns.DATA1) : 0;
        if (mIsCreate || mDataContentData1 != dataContentData1) {
            mDiffDataValues.put(DataColumns.DATA1, dataContentData1);
        }
        mDataContentData1 = dataContentData1;

        String dataContentData3 = js.has(DataColumns.DATA3) ? js.getString(DataColumns.DATA3) : "";
        if (mIsCreate || !mDataContentData3.equals(dataContentData3)) {
            mDiffDataValues.put(DataColumns.DATA3, dataContentData3);
        }
        mDataContentData3 = dataContentData3;
    }

    /**
     * 将成员变量的值转换为JSON对象并返回。
     * @return JSONObject 对象包含了 SqlData 对象中各个成员变量的值，使用相应的键值表示。如果当前对象是新创建的，则打印错误日志并返回 null。
     * @throws JSONException 抛出的异常
     */
    public JSONObject getContent() throws JSONException {
        if (mIsCreate) {
            Log.e(TAG, "it seems that we haven't created this in database yet");
            return null;
        }
        JSONObject js = new JSONObject();
        js.put(DataColumns.ID, mDataId);//将类的成员变量 mDataId 的值存储到 js 对象中，使用键名 DataColumns.ID。
        js.put(DataColumns.MIME_TYPE, mDataMimeType);//将类的成员变量 mDataMimeType 的值存储到 js 对象中，使用键名 DataColumns.MIME_TYPE
        js.put(DataColumns.CONTENT, mDataContent);
        js.put(DataColumns.DATA1, mDataContentData1);
        js.put(DataColumns.DATA3, mDataContentData3);
        return js;
    }

    /**
     * 提交数据的更改到数据库中。如果是新创建的数据，则将数据插入数据库并获取其ID；如果是已存在的数据，则根据mDiffDataValues对象中的差异字段值更新数据库中对应的记录。
     * @param noteId 便签的ID，表示要提交数据的便签的ID
     * @param validateVersion 布尔值，表示是否需要验证版本号
     * @param version 长整型数，表示版本号
     */
    public void commit(long noteId, boolean validateVersion, long version) {

        if (mIsCreate) {//如果数据是新创建的
            if (mDataId == INVALID_ID && mDiffDataValues.containsKey(DataColumns.ID)) {
                mDiffDataValues.remove(DataColumns.ID);
            }

            mDiffDataValues.put(DataColumns.NOTE_ID, noteId); //设置便签的ID
            Uri uri = mContentResolver.insert(Notes.CONTENT_DATA_URI, mDiffDataValues);//向数据库中插入数据
            try {
                mDataId = Long.valueOf(uri.getPathSegments().get(1));
            } catch (NumberFormatException e) {
                Log.e(TAG, "Get note id error :" + e.toString());
                throw new ActionFailureException("create note failed");
            }
        } else {//如果不是新创建的数据
            if (mDiffDataValues.size() > 0) {
                int result = 0;
                if (!validateVersion) {//如果不用验证版本，直接更新数据
                    result = mContentResolver.update(ContentUris.withAppendedId(
                            Notes.CONTENT_DATA_URI, mDataId), mDiffDataValues, null, null);
                } else {//如果要验证版本，根据版本号更新数据
                    result = mContentResolver.update(ContentUris.withAppendedId(
                            Notes.CONTENT_DATA_URI, mDataId), mDiffDataValues,
                            " ? in (SELECT " + NoteColumns.ID + " FROM " + TABLE.NOTE
                                    + " WHERE " + NoteColumns.VERSION + "=?)", new String[] {
                                    String.valueOf(noteId), String.valueOf(version)
                            });
                }
                if (result == 0) {
                    Log.w(TAG, "there is no update. maybe user updates note when syncing");
                }
            }
        }

        mDiffDataValues.clear();//提交后清空数据
        mIsCreate = false;
    }

    /**
     * 返回成员变量mDataId的值。
     * @return 成员信息的ID
     */
    public long getId() {
        return mDataId;
    }
}
